
#include "rumd/Potential.h"
#include "rumd/Sample.h"
#include "rumd/ParticleData.h"

Potential::Potential() : 
  nParticles(0),
  d_r(0),
  d_f(0),
  d_w(0),
  d_sts(0),
  d_misc(0),
  particleData(0),
  verbose(true),
  ID_String("pot")
{
}

void Potential::SetSampleParameters(KernelPlan &kPlan, ParticleData* pd, SimulationBox* simBox, float4* d_misc)
{
  this->simBox = simBox;
  kp = kPlan;  
  particleData = pd;

  nParticles = particleData->GetNumberOfParticles();
  assert(nParticles > 0);

  d_r = particleData->d_r;
  d_f = particleData-> d_f;
  d_w = particleData-> d_w; 
  d_sts = particleData->d_sts;
  h_Type = particleData->h_Type;

  this->d_misc = d_misc;
}
